--scenario utilities
local ScenarioUtils = import('/lua/sim/ScenarioUtilities.lua')
local ScenarioFramework = import('/lua/ScenarioFramework.lua')
local Utilities = import('/lua/utilities.lua')

local executing = false
local beatTime = 5
local beat = 0


local playersDATA = {
	['player1'] = {
		name = 'player1',
    nuclear = {},
    nbnuclear = 0,
    xstartlocation = 256,
    zstartlocation = 256,
  },
  ['player2'] = {
		name = 'player2',
    nuclear = {},
    nbnuclear = 0,
    xstartlocation = 768,
    zstartlocation = 768,
  },
  ['player3'] = {
		name = 'player3',
    nuclear = {},
    nbnuclear = 0,
    xstartlocation = 768,
    zstartlocation = 256,
  },
  ['player4'] = {
		name = 'player4',
    nuclear = {},
    nbnuclear = 0,
    xstartlocation = 256,
    zstartlocation = 768,
  }
}

local players = {}


local armyTable = {
	 ['ARMY_1'] = 'player1',
	 ['ARMY_2'] = 'player2',
	 ['ARMY_3'] = 'player3',
	 ['ARMY_4'] = 'player4',
}

scnPrint = function(text)
  PrintText(text,20,888888,10,'center')
end

--given a player returns an army
toArmy = function(player)
	local army = false
	for i,v in armyTable do
		if v == player.name then
			army = i
		end
	end
	return army
end
--*****************************************************************************
function OnPopulate()
  ScenarioUtils.InitializeArmies()
end


function OnStart(self)

  InitializeArmies()

  local batiment
  --powgen T3
  batiment = CreateUnitHPR( 'ueb1301', 'ARMY_9',505,54,511, 0,0,0) 
  makeInvincible(batiment)
  batiment = CreateUnitHPR( 'ueb3104', 'ARMY_9',518,54,511, 0,0,0)
  makeInvincible(batiment)
  
 
  spawnNuclearLauncher()
  local mainThread = ForkThread(function(self)
    while true do
			--secutiry for slow computers
			while executing == true do
			end
      --call main thread beat
      mainThreadBeat()
      
      if math.mod(beat,12)==0 and beat>0 then
        -- une minute, on, ajoute un nucleaire
        spawnNuclearLauncher()
      end
      
      --increment beat count
      beat = beat + 1

      --wait time between each beat
      WaitSeconds(beatTime)
    end
  end)
end

function InitializeArmies()
  local tblArmy = ListArmies()
	for index,army in tblArmy do
    if army!='ARMY_9' then
  		players[armyTable[army]] = playersDATA[armyTable[army]]
      SetAlliance( army, 'ARMY_9', 'Ally')
    end
	end
end

--MAIN SCENARIO THREAD
--do map script actions every TICK
mainThreadBeat = function()
	executing = true
	spawnNuclear()
	executing = false
end

function spawnNuclearLauncher()
  for index, player in players do
    if player.nbnuclear==0 then
      player.nbnuclear=player.nbnuclear+1
      player.nuclear[player.nbnuclear] = CreateUnitHPR( 'ueb2305', toArmy(player), player.xstartlocation,64,player.zstartlocation, 0,0,0)
      makeInvincible(player.nuclear[player.nbnuclear]);
      --Loading module '/projectiles/tifmissilenuke01/tifmissilenuke01_script.lua'
--Loading module '/lua/terranprojectiles.lua'
    else
      if player.nbnuclear<5 then
        player.nbnuclear=player.nbnuclear+1
        player.nuclear[player.nbnuclear] = CreateUnitHPR( 'ueb2305', toArmy(player), player.xstartlocation + (math.pow(-1,math.mod(player.nbnuclear-1,3))*5),64,player.zstartlocation + (math.pow(-1,math.mod(player.nbnuclear,4))*5), 0,0,0)
        makeInvincible(player.nuclear[player.nbnuclear]);
      end
    end
  end
  
end

function spawnNuclear()
  for index, player in players do
    for index, nuc in player.nuclear do
      if nuc:GetNukeSiloAmmoCount()==0 then
        nuc:GiveNukeSiloAmmo(1)
      end
    end
  end
end

--makes a unit invincible
makeInvincible = function(unit)		
	unit:SetDoNotTarget(true)
	unit:SetCanBeKilled(false)
	unit:SetCapturable(false)
	unit:SetReclaimable(false)
	unit:SetDoNotTarget(true)
	unit:SetMaxHealth(1)
	unit:SetHealth(nil,1)
	unit:SetRegenRate(1)
end

